module data.buffer {
   new =
      (Acc = data.ref.backtrackable:new([])) >>
      module {
         atom = data.string:atom(string).

         string = data.list.(flatten(reverse(Acc:get))).

         write(C) :-
            Acc:set([[C] | Acc:get]).

         print(Term) :-
            Acc:set([kernel:string_print(Term) | Acc:get]).

         print_endline(Term) :-
            print(Term),
            endline.

         endline :-
            write('\n').

         format(Format, Args) :-
            Acc:set([kernel:string_format(Format, Args) | Acc:get]).
      }.
}