module emop.patch_runtime {
   import: io.std.

   main :-
      catch(
         (
            parse_cmdline(OriginalFile, NewFile),
            Patcher = emop.patch_wam:make() {
               do(
                  ['cut'(V), 'put_atom'('$cut', R) | Tail],
                  ['put_value'(V, R)],
                  Tail
               )
            },
            Patcher:stream(OriginalFile, NewFile)
         ),
         E,
         (
            io.err:print_endline(E),
            sys.process:exit(1)
         )
      ).

   parse_cmdline(OriginalFile, NewFile) :-
      sys.cmdline:parse() {
         long(_, _) :- fail.
         short(_, _) :- fail.
         default(_) :- fail.
         file(Filename) :-
            (
               data.var:check(OriginalFilename)
            ->
               OriginalFilename = Filename
            ;
               data.var:check(NewFilename)
            ->
               NewFilename = Filename
            ;
               throw('Please supply only two filenames.')
            ).
      },
      (
         OriginalFilename = '-'
      ->
         OriginalFile = io.std
      ;
         OriginalFile = io.file:open_read(OriginalFilename)
      ),
      (
         NewFilename = '-'
      ->
         NewFile = io.std
      ;
         NewFile = io.file:open_write(NewFilename)
      ).
      
}