module emop.patch_wam {
   make(Patch) = module {
      stream(OriginalFile, NewFile) :-
         (
            repeat,
            OriginalFile:read_term(T),
            (
               T \= 'end_of_file'
            ->
               portray_wam(NewFile, clause(T)),
               fail
            ;
               true
            )
         ->
            true
         ).

      clause(Clause) =
         Clause match (
            data.term:make(_, data.list:append(_, [([ _ | _ ] & | ! >> instr)]))
         ;
            _
         ).

      instr([]) = ! >> [].

      instr(List, Result) :-
         (
            Patch:do(List, NewList, Tail)
         ->
            Result = data.list:append(NewList, NewTail),
            instr(Tail, NewTail)
         ;
            List = [H | T]
         ->
            Result = [H | instr(T)]
         ).
   }.

   portray_wam(NewFile, Clause) :-
      (
         Clause match data.term:make(
            'predicate',
            data.list:append(OtherArgs, [[First | Tail]])
         )
      ->
         NewFile:print('predicate('),
         (
            data.list:member(Arg, OtherArgs),
            NewFile:format('~q, ', [Arg]),
            fail
         ;
            true
         ),
         NewFile:format('[\n    ~q', [First]),
         (
            data.list:member(Instr, Tail),
            NewFile:format(',\n    ~q', [Instr]),
            fail
         ;
            true
         ),
         NewFile:print(']).\n\n')
      ;
         NewFile:format('~q.\n\n', [Clause])
      ).
}